--[[
	Kui Mount
	Kesava-Auchindoun
]]

local blacklist = {
	['Celestial Steed'] = true,
}

local function Mount()
	-- Dismount ----------------------------------------------------------------
	if UnitInVehicle('player') then 
		VehicleExit()
		return
	end
	if IsMounted('player') then
		Dismount()
		return
	end

	if InCombatLockdown() then
		return
	end

	-- Collect usable mounts ---------------------------------------------------
	local mounts = GetNumCompanions('mount')
	if mounts <= 0 then
		print('Kui_Mount: you don\'t have any mounts, silly.')
		return
	end
	
	local usable = {}
	local useFlying = not IsControlKeyDown() and IsFlyableArea()
	
	local swimZones = {
		['Vashj\'ir'] = true,
		['Abyssal Depths'] = true,
		['Kelp\'thar Forest'] = true,
		['Shimmering Expanse'] = true,
		['Damplight Chamber'] = true
	}
	local isSwimZone = swimZones[GetZoneText()]
	
	for i = 1, mounts do
		local _, name, id = GetCompanionInfo('mount', i) 
		local desc = GetSpellDescription(id)
		local hybrid, flying = strfind(desc, 'mount changes')
		
		if not hybrid then
			flying = strfind(desc, 'flying')
		end
		
		if isSwimZone and name == 'Abyssal Seahorse' and not IsShiftKeyDown() then
			-- select the seapony
			usable = { id }
			break
		end
		
		if IsUsableSpell(id) and (not blacklist[name] or IsAltKeyDown()) then
			if useFlying then
				if flying or hybrid then
					tinsert(usable, id)
				end
			else
				if not flying or hybrid then
					tinsert(usable, id)
				end
			end
		end
	end
	
	-- Select usable mount -----------------------------------------------------
	if #usable > 0 then
		local name = GetSpellInfo(usable[math.random(1, #usable)])
		CastSpellByName(name)
	else
		print('Kui_Mount: couldn\'t select a usable mount.')
	end
end

--------------------------------------------------------------- Slash command --
SLASH_KUIMOUNT1 = '/kuimount'
SLASH_KUIMOUNT2 = '/mount'

function SlashCmdList.KUIMOUNT()
	Mount()
end